package org.acme.core;


import io.quarkus.vertx.ConsumeEvent;
import io.vertx.core.AbstractVerticle;
import io.vertx.core.Promise;
import io.vertx.core.eventbus.DeliveryOptions;
import io.vertx.core.json.JsonArray;
import io.vertx.core.json.JsonObject;
import io.vertx.oracleclient.OraclePool;
import io.vertx.oracleclient.OraclePrepareOptions;
import org.acme.aux.Translate;
import org.jboss.logging.Logger;


import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.CompletionStage;

@ApplicationScoped
public class DbVerticle extends AbstractVerticle {

    private static final Logger logger = Logger.getLogger(DbVerticle.class);

    private static final DeliveryOptions dops = new DeliveryOptions();

    @Inject
    OraclePool dbClient;

    private OraclePrepareOptions oracleOptions = new OraclePrepareOptions();

    @Override
    public void start(Promise promise){
        oracleOptions.setAutoGeneratedKeys(false);

        logger.info("Conectando a la DB");

        dbClient.getConnection(ar -> {
            if(ar.failed()){
                logger.error("error durante la conexion");
                promise.fail(ar.cause());

            } else {
                logger.info("conexion OK");

                initDB();
                promise.complete();
            }
        });

    }


    // El msg contiene la informacion necesaria para determinar a que Service se envia la solitud
    // para ser procesada.
    @ConsumeEvent("insert")
    public CompletionStage insert(JsonObject msg){
        return null;
    }

    @ConsumeEvent("delete")
    public CompletionStage delete(JsonObject msg){
        return null;
    }

    @ConsumeEvent("update")
    public CompletionStage update(JsonObject msg){
        return null;
    }

    @ConsumeEvent("get")
    public CompletionStage<JsonObject> get(JsonObject msg){
        var future = new CompletableFuture<JsonObject>();

        var successStatusCode = 200;
        var id = msg.getValue("id");
        var entity = msg.getValue("entity");
        var query = String.format("SELECT * FROM %s WHERE id=%s", entity, id);

        return executeQuery(query, successStatusCode, future);
    }


    private CompletionStage<JsonObject> executeQuery(String query, Integer successStatusCode, CompletableFuture future){

        dbClient.query(query).execute(ar -> {
            var response = new JsonObject();

            if (ar.succeeded()) {
                logger.warn("Query SUCCESS");

                JsonArray rows = Translate.translateAll(ar.result());

                response.put("statusCode", successStatusCode);
                response.put("error", false);
                response.put("message", rows.isEmpty() ? "Cannot found data" : rows);

            } else {
                logger.error("Error en consulta GET " + " con causa: " + ar.cause());

                response.put("statusCode", 400);
                response.put("error", true);
                response.put("message", ar.cause());

            }

            future.complete(response);
        });

        return future;
    }


    private void initDB(){
        logger.info("Iniciando DB");

        vertx.executeBlocking(ar -> {
            dbClient.query("  BEGIN\n" +
                            "      EXECUTE IMMEDIATE ('DROP TABLE posts');\n" +
                            "  EXCEPTION\n" +
                            "      WHEN OTHERS THEN NULL;\n" +
                            "  END;").execute()
                    .flatMap( r -> dbClient.query("CREATE TABLE posts (\n" +
                            "    id NUMBER GENERATED ALWAYS as IDENTITY(START with 1 INCREMENT by 1),\n" +
                            "    content varchar2(255) NOT NULL\n" +
                            ")").execute())
                    .flatMap(r -> dbClient.query("INSERT INTO posts (content) VALUES ('Este es mi primer POST')").execute())
                   .flatMap(r -> dbClient.query("INSERT INTO posts (content) VALUES ('Este es mi segundo POST')").execute())
                   .flatMap(r -> dbClient.query("INSERT INTO posts (content) VALUES ('Veamos que pasa con el tercero')").execute())
                   .flatMap(r -> dbClient.query("INSERT INTO posts (content) VALUES ('Y este es el cuarto REY!')").execute())
                    .andThen(response -> {
                        if (!response.succeeded()){
                            logger.error("no se pudo ejecutar la sentencia SQL");
                            logger.error(response.cause());
                        } else {
                            logger.info("Sentencias SQL OK");
                            ar.complete();
                        }
                    });

        });
    }

}
